<script>
    import ChatItem from '@/components/panel/ChatItem.vue';
    import ChatTray from '@/components/panel/ChatTray.vue';
    import ClientData from '@/components/panel/ClientData.vue';
    import SearchComponent from '@/components/panel/SearchComponent.vue';

    export default {
        components: { ChatItem, ChatTray, ClientData, SearchComponent  },
        data: () => ({
            modalClientData: false,
            activeIndex: null,
            clients: [],
            searchStr: '',
            client: {
                data: {},
                chat: []
            },

            /* ONLY TEST */
            chats: [
                {
                    _id: 1,
                    name: 'Julia Mendez',
                    message: 'Hola buenos dias',
                    img: 'chat-1',
                    state: 'seen',
                    time: '10 minutos'
                },
                {
                    _id: 2,
                    name: 'Gerardo Torres',
                    message: 'Gracias, estaré atento.',
                    img: 'chat-2',
                    state: 'new',
                    time: '5 minutos'
                },
                {
                    _id: 3,
                    name: 'Gaby Herrera',
                    message: 'Saludos',
                    img: 'chat-default',
                    state: 'seen',
                    time: '10 minutos'
                },
                {
                    _id: 4,
                    name: 'Patricio Hurtado',
                    message: 'Gracias',
                    img: 'chat-default',
                    state: 'seen',
                    time: '20 minutos'
                },
                {
                    _id: 5,
                    name: 'Sandy Valencia',
                    message: 'Espero te sea de utilidad',
                    img: 'chat-3',
                    state: 'new',
                    time: '35 minutos'
                },
                {
                    _id: 6,
                    name: 'Jhon',
                    message: 'De acuerdo',
                    img: 'chat-default',
                    state: 'seen',
                    time: '40 minutos'
                }
            ],
        }),
        computed: {
            listResults() {
                return this.clients.filter(i =>
                    i.name.toLowerCase().includes(this.searchStr.toLowerCase())
                );
            },
        },
        methods: {
            async getClients(){
                try {
                    const res = await fetch('https://sellia-web-page-test.s3.us-east-2.amazonaws.com/clients.json');
                    const jsonData = await res.json();
                    this.clients = jsonData;

                    this.chats.map((client) => {
                        this.clients.push(client);
                    });
                } catch (error) {
                    console.log(error);
                    err.value = 'Error de api'
                } finally {
                    //
                }
            },
            async getMessages(id){
                try {
                    const res = await fetch('https://sellia-web-page-test.s3.us-east-2.amazonaws.com/'+ id +'.json');
                    const jsonData = await res.json();
                    this.client.chat = jsonData;
                } catch (error) {
                    console.log(error);
                    err.value = 'Error de api'
                } finally {
                    // 
                }
            },
            setCurrentClient($event){
                this.client = { data: {}, chat: [] }
                this.getMessages($event._id);
                this.client.data = $event;
            },
            onToggle(idx) {
                this.activeIndex === idx ? this.activeIndex = null : this.activeIndex = idx;
            },
            toSearch($event){
                this.searchStr = $event;
            }
        },
        mounted(){
            this.getClients();
        }
    }
</script>

<template>
    <div class="chats-component h-100vh">
        <div class="container h-100pr">
            <div class="gs:grid h-100pr relative">
                <div class="col-24 lg:col-6 py-6 border-r-1 h-100vh pt-35 xl:pt-5 flex flex-column justify-start">
                    <div class="flex justify-between align-center mb-4">
                        <h1 class="tx-20 mb-0">
                            Chats
                        </h1>
                        <img class="w-6 cursor-pointer" src="@/assets/images/views/panel/icon-new-chat.svg" alt="">
                    </div>

                    <!-- SEARCH -->
                    <search-component @toSearch="toSearch($event)"/>

                    <!-- CHAT LIST -->
                    <ul class="chat-list max-h-100pr overflow-auto m-0 pl-0 pt-2">
                        <chat-item :class="activeIndex === idx && 'active'" @onToggle="onToggle(idx)" :data="client" v-for="(client, idx) in listResults" :key="'client_' + idx" @getClient="setCurrentClient($event)"/>
                    </ul>
                </div>

                <!-- INIT -->
                <div class="col-18 hidden lg:flex flex-column align-center justify-center h-100vh" v-if="!client.data.name">
                    <img class="mb-5" src="@/assets/images/layout/logo-hey-center.png" alt="">
                    <p class="tx-center opacity-06">
                        Web app de mensajería omnicanal <strong>HEYCENTER</strong>
                    </p>
                </div>
                <template v-else>
                    <div class="col-12 border-r-1 hidden lg:block">
                        <chat-tray :currentClient="client.data" :currentChat="client.chat"/>
                    </div>
                    <div class="col-6 hidden lg:block">
                        <client-data :currentClient="client.data"/>
                    </div>
                </template>
                
                <!-- CHAT TRAY MOBILE -->
                <chat-tray class="absolute t-0 l-0 h-100vh lg:hidden" :currentClient="client.data" :currentChat="client.chat" v-if="client.data.name" @closeTray="client = { data: {}, chat: [] }" @openData="modalClientData = true"/>

                <!-- CLIENT DATA MOBILE -->
                <transition name="fade" class="lg:hidden">
                    <div class="modal active pt-40" v-if="modalClientData">
                        <div class="modal-lightbox max-w-100">
                            <div class="modal-close tx-40" @click="modalClientData = false">
                                &times;
                            </div>
                            <client-data :currentClient="client.data"/>
                        </div>
                    </div>
                </transition>
            </div>
        </div>
    </div>
</template>
